import javax.swing.*;
import javax.swing.tree.*;

public class ConsoleNamingContext extends ConsoleNode
{
	/**
	 * Reference vers le naming context
	 */
	protected org.omg.CosNaming.NamingContext _nc;

	/**
	 * Reference vers le binding name
	 */
	protected org.omg.CosNaming.NameComponent _n;

	public ConsoleNamingContext( String name )
	{
		super(name,null,false);
	}

	public ConsoleNamingContext( String name, ConsoleNode parent )
	{
		super(name,parent,false);
	}

	public ConsoleNamingContext addNamingContext( String name )
	{
		ConsoleNamingContext node = new ConsoleNamingContext(name,this);
		
		addChild(node);

		return node;
	}

	public ConsoleObject addObject( String name )
	{
		ConsoleObject obj = new ConsoleObject(name,this);

		addChild(obj);

		return obj;
	}

	public void setNamingContext( org.omg.CosNaming.NamingContext nc, org.omg.CosNaming.NameComponent n )
	{
		_nc = nc;
		_n = n;
	}

	public org.omg.CosNaming.NameComponent getName()
	{
		return _n;
	}


	public org.omg.CosNaming.NamingContext getNamingContext()
	{
		return _nc;
	}
}