// ---------------------------------------------------------------------
// JavaORB 2.0
//
//                        Object by value Tutorial
//
// Step 3 / Using inherited value type
// ---------------------------------------------------------------------

/**
 * This class implements a server.
 * 
 * @author	Jerome DANIEL
 * @version	1.0
 */
public class Server
{
	public static void main( String args[] )
	{
		// .1
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);		

		// 2.
		// Initialize the BOA
		org.omg.CORBA.BOA boa = org.omg.CORBA.BOA.init(orb,args);

		// 3.
		// Instanciate Calculator object
		ValueExchangeImpl value = new ValueExchangeImpl();		
			
		// 4.
		// Connect the instance to BOA
		boa.connect(value);
		
		// 5.
		// Activate the instance
		boa.obj_is_ready(value);		
		
		// 6.
		// Create value factories
		valueBaseFactory factoryBase = new valueBaseFactory();
		subValueFactory factorySub = new subValueFactory();

		// 7.
		// Register value factories
		((org.omg.CORBA_2_3.ORB)orb).register_value_factory( aValueBaseHelper.id(), factoryBase );
		((org.omg.CORBA_2_3.ORB)orb).register_value_factory( aSubValueHelper.id(), factorySub );
		
		// 8.
		// Export into a file the object reference
		String reference = orb.object_to_string(value);
		try
		{
			java.io.FileOutputStream file = new java.io.FileOutputStream("ObjectId");
			java.io.PrintStream pfile=new java.io.PrintStream(file);
			pfile.println(reference);
		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
		}

		// 9.
		// Wait for invocations
		try
		{
			System.out.println("The server is ready...");
			boa.impl_is_ready();
		}
		catch ( java.lang.Exception ex )
		{
			System.out.println("An exception has been intercepted.");
		}

	}
}