// ============================================================
// = CORBA Sample				                              =
// ============================================================

public class Server
{
	public static void main( String args[] )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
		
		// 2.
		// Resolve for RootPOA reference
		org.omg.CORBA.Object objPoa = null;		
		org.omg.PortableServer.POA rootPOA = null;
		try
		{
			objPoa = orb.resolve_initial_references("RootPOA");			
		}
		catch ( org.omg.CORBA.ORBPackage.InvalidName ex )
		{}		

		// 3.
		// Narrow the RootPOA reference
		rootPOA = org.omg.PortableServer.POAHelper.narrow(objPoa);		

		// 4.
		// Instanciate a Calculator object
		CalculatorImpl calc = new CalculatorImpl();
		
		try
		{
			// define policies for child POA
			org.omg.CORBA.Policy [] policies = new org.omg.CORBA.Policy[1];

			policies[0] = 
				rootPOA.create_id_assignment_policy( 
					org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID );

			// Create the child POA
			org.omg.PortableServer.POA childPOA = rootPOA.create_POA("MyPOA", rootPOA.the_POAManager(), policies);

			// Create the servant ID
			byte [] servantId = (new String("Calculator")).getBytes();

			// Activate the servant into the child POA with the ID " Calculator "
			childPOA.activate_object_with_id(servantId,calc);

			// Get the servant reference
			org.omg.CORBA.Object obj = childPOA.id_to_reference(servantId);
						
			// Export into a file the servant reference
			String reference = orb.object_to_string(obj);			
			try
			{
				java.io.FileOutputStream file = new java.io.FileOutputStream("ObjectId");
				java.io.PrintStream pfile=new java.io.PrintStream(file);
				pfile.println(reference);
			}
			catch ( java.io.IOException ex )
			{
				System.out.println("File error");
			}

			// Activate the POA by its manager way
			rootPOA.the_POAManager().activate();

			System.out.println("Server is ready...");
			
			// Run and wait for invocations
			orb.run();
		}
		catch ( java.lang.Exception ex )
		{			
			System.out.println("An exception has been intercepted");
			ex.printStackTrace();
		}

	}
}