// ===========================================================
//
// This example is extracted from CORBA Specification  9.6.10
// It shows how to use a single servant to manage several
// objects
//
// Jerome DANIEL
// ===========================================================

/*-----------------------------------------------------------*\
 *			           Client implementation				 *
\*-----------------------------------------------------------*/

public class Client
{
	public static void main( String args[] )
	{
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

		// Get the FileSystme reference from a file
		FileSystem fileSys = null;
		org.omg.CORBA.Object obj = null;
		try
		{
			java.io.FileInputStream file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			String stringTarget = myInput.readLine();

			obj = orb.string_to_object(stringTarget);
		}
		catch ( java.io.IOException ex )
		{
			System.out.println("Impossible d'importer la reference du serveur");
			System.exit(0);
		}

		// Narrow the object reference
		fileSys = FileSystemHelper.narrow(obj);		

		// Use the FileSystem
		try
		{
			System.out.println("Open file : TEST.TXT");

			FileDescriptor fd = fileSys.open("TEST.TXT",0);

			String contenu = new String( fd.read(100) );

			System.out.println("File data : ");
			System.out.println( contenu );
			System.out.println("");

			System.out.println("Open another file : OTHERTEST.TXT");

			FileDescriptor fd2 = fileSys.open("OTHERTEST.TXT",0);

			contenu = new String( fd2.read(150) );

			System.out.println("File data : ");
			System.out.println( contenu );
			System.out.println("");

		}		
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA system exception has been intercepted");
			System.out.println(ex.getMessage());
		}

	}
}