// ===========================================================
// 
// This sample is an adaptation of CORBA specification example
// for POA  9.6.6. It shows how to develop a ServantActivator
//
// Jerome DANIEL
// ===========================================================

/*-----------------------------------------------------------*\
 *					ServantActivator implementation 		 *
\*-----------------------------------------------------------*/

public class SrvActivator extends org.omg.PortableServer.ServantActivatorPOA
{
	/**
	 * Operation Incarnate
	 *
	 * This function is called to return a servant
	 *
	 * @param	oid			the object id of the waited object
	 * @param	adapter		an object adapter reference
	 * @return	the found servant
	 */
	public org.omg.PortableServer.Servant incarnate(
			byte[] oid, 
			org.omg.PortableServer.POA adapter )
		throws org.omg.PortableServer.ForwardRequest
	{
		String oid_str = new String( oid );

		if ( oid_str.equals("MyOwnId") )
		{
			return new CalculatriceImpl();
		}
		else
			throw new org.omg.CORBA.OBJECT_NOT_EXIST();
	}

	/**
	 * Operation etherealize
	 */
	public void etherealize(
		byte[] oid, 
		org.omg.PortableServer.POA adapter, 
		org.omg.PortableServer.Servant serv, 
		boolean cleanup_in_progress, 
		boolean remaining_activations)
	{
		if ( remaining_activations == false )
			serv = null;
	}
}

