// ============================================================
// = CORBA Sample											  =
// ============================================================

//
// Applet sample
//
public class Client extends java.applet.Applet
				    implements java.awt.event.ActionListener				
{
	/**
	 * Reference to the remote object
	 */
	Calculator calc = null;
	
	/**
	 * Reference to the GUI components
	 */
	public java.awt.TextField op1_field = null;
	public java.awt.TextField op2_field = null;
	public java.awt.Button addition_button = null;
	public java.awt.Button division_button = null;
	public java.awt.TextField result_field = null;
	
	/**
	 * Draw the applet
	 */
	public void draw()
	{
		System.out.println("Ok");
		
		setLayout( new java.awt.GridLayout(4,1) );				
		
		java.awt.Panel op1_panel = new java.awt.Panel();
		op1_panel.setLayout( new java.awt.GridLayout(1,2) );		
		op1_panel.add( new java.awt.Label("First number") );
		op1_field = new java.awt.TextField();
		op1_panel.add( op1_field );
		
		java.awt.Panel op2_panel = new java.awt.Panel();
		op2_panel.setLayout( new java.awt.GridLayout(1,2) );		
		op2_panel.add( new java.awt.Label("Second number") );
		op2_field = new java.awt.TextField();
		op2_panel.add( op2_field );
		
		java.awt.Panel button_panel = new java.awt.Panel();
		button_panel.setLayout( new java.awt.GridLayout(1,2) );		
		addition_button = new java.awt.Button("Addition");
		button_panel.add( addition_button );
		addition_button.addActionListener( this );
		division_button = new java.awt.Button("Division");
		division_button.addActionListener( this );
		button_panel.add( division_button );		
		
		java.awt.Panel result_panel = new java.awt.Panel();		
		result_panel.setLayout( new java.awt.GridLayout(1,1) );
		result_field = new java.awt.TextField();
		result_panel.add( result_field );
		
		add( op1_panel );
		add( op2_panel );
		add( button_panel );
		add( result_panel );
		
		repaint();
	}
	
	/**
	 * Manage events
	 */
	public void actionPerformed( java.awt.event.ActionEvent ev) 
	{
		float op1, op2, res;
		
		if ( ev.getSource() == addition_button )
		{
			op1 = new Float( op1_field.getText() ).floatValue();
			op2 = new Float( op2_field.getText() ).floatValue();
			
			try
			{
				res = calc.add( op1, op2 );
				
				result_field.setText( "" + res );
			}
			catch ( org.omg.CORBA.COMM_FAILURE ex )
			{ 
				result_field.setText("Exception : org.omg.CORBA.COMM_FAILURE");
			}
		}
		else
		if ( ev.getSource() == division_button )
		{
			op1 = new Float( op1_field.getText() ).floatValue();
			op2 = new Float( op2_field.getText() ).floatValue();
			
			try
			{
				res = calc.div( op1, op2 );
				
				result_field.setText( "" + res );
			}
			catch ( DivisionByZero ex )
			{
				result_field.setText("User exception : DivisionByZero");
			}
			catch ( org.omg.CORBA.COMM_FAILURE ex )
			{ 
				result_field.setText("Exception : org.omg.CORBA.COMM_FAILURE");
			}			
		}
    }
	
	
	/**
	 * This is the entry point for an Applet
	 */
	public void init()
	{							
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this,null);

		// 2.
		// Resolve the NameService 
		org.omg.CORBA.Object obj = null;
		org.omg.CosNaming.NamingContext naming = null;		
		try
		{			
			obj = orb.resolve_initial_references("NameService");
			naming = org.omg.CosNaming.NamingContextHelper.narrow(obj);
		}
		catch ( org.omg.CORBA.ORBPackage.InvalidName name )
		{
			System.out.println("Enable to resolve NameService");
			System.exit(0);
		}
		
		// 3.
		// Build Calculator path 
		org.omg.CosNaming.NameComponent [] name = new org.omg.CosNaming.NameComponent[1];
		name[0] = new org.omg.CosNaming.NameComponent();
		name[0].id = "Calculator";
		name[0].kind = "Example";
		
		// 4. 
		// Resolve Calculator reference from NameService
		try
		{
			obj = naming.resolve(name);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.NotFound ex )			
		{
			System.out.println("Object not found");
			System.exit(0);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.CannotProceed ex )
		{
			System.out.println("Cannot proceed");
			System.exit(0);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.InvalidName ex )
		{
			System.out.println("Invalid name");
			System.exit(0);
		}
						
		// 3.
		// Narrow the object reference
		calc  = CalculatorHelper.narrow(obj);	
		
		draw();
	}
}