// -------------------------------------------------------------
// JavaORB
//
//			Request Interceptor Example
//
// (c) Distributed Object Group, 1999
// -------------------------------------------------------------

public class myRequestInterceptor implements JavaORB.Interceptor.RequestInterceptor
{
	/**
	 * Operation client_pre_invoke
	 */
	public void client_pre_invoke(java.lang.String Operation, org.omg.CORBA.portable.OutputStream dataOut, org.omg.CORBA.Object target, JavaORB.CORBA.ContextTypeHolder ctx)
	{
		System.out.println("[ client side ] Asked operation : " + Operation );
		
		String name = System.getProperty("user.name");
		
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
		
		org.omg.CORBA.Any any = orb.create_any();
		
		any.insert_string( name );
		
		JavaORB.Interceptor.StreamManager.insertIntoOutputStream( any, dataOut );		                                  
		
		ctx.value = new JavaORB.CORBA.ContextType();
		
		ctx.value.add("UserName", name );
	}

	/**
	 * Operation client_post_invoke
	 */
	public void client_post_invoke(java.lang.String Operation, org.omg.CORBA.portable.InputStream dataIn, org.omg.CORBA.Object target, JavaORB.CORBA.ContextType ctx)
	{
		System.out.println("[ client side ] After invocation of : " + Operation );
		
		String name = ( String ) ctx.item("UserName");
		
		System.out.println("The user name was " + name );
	}

	/**
	 * Operation target_pre_invoke
	 */
	public boolean target_pre_invoke(java.lang.String Operation, org.omg.CORBA.portable.InputStream dataIn, org.omg.CORBA.Object target, JavaORB.CORBA.ContextTypeHolder ctx)
	{
		System.out.println("[ server side ] Asked operation : " + Operation );
		
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
		
		org.omg.CORBA.Any any = orb.create_any();
		
		any.type( orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string ) );
		
		JavaORB.Interceptor.StreamManager.extractFromInputStream( any, dataIn );
		
		String name = any.extract_string();
		
		System.out.println("This call emitter is " + name );
		
		return false;
	}

	/**
	 * Operation target_post_invoke
	 */
	public void target_post_invoke(java.lang.String Operation, org.omg.CORBA.portable.OutputStream request, org.omg.CORBA.Object target, JavaORB.CORBA.ContextType ctx)
	{
		// Nothing here
	}

}