/**
 * This class is an example for Thread policies under JavaORB.
 * 
 * @author	Jerome DANIEL
 * @version	1.0
 */
public class Server 
{
		
	public static void main( String [] args ) 
	{
		// Check for arguments
		if ( args.length == 0 )
		{
			System.out.println("Please pass as argument the thread policy");
			System.out.println("");
			System.out.println("single ........... for SINGLE_THREAD");
			System.out.println("request .......... for THREAD_PER_REQUEST");
			System.out.println("client ........... for THREAD_PER_CLIENT");
			System.out.println("");
			System.exit(0);
		}
		
		// 1.
		// Initialise the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init( args, null );
		
		// 2.
		// Now activate the object adapter ( either BOA or POA ). To be simple, we
		// decide to take BOA
		org.omg.CORBA.BOA boa = org.omg.CORBA.BOA.init( orb, args );
		
		// 3. 
		// Now, create an object instance
		counterImpl c = new counterImpl(1000);
		
		// 4.
		// Connect the object to the adaptor		
		boa.connect(c);
		obj_is_ready(c);
		
		// 5.
		// Select the thread policy for this object
		if ( args[0].equals("single") )
		{
			System.out.println("SINGLE_THREAD policy selected...");
			
			org.omg.CORBA.Policy [] policy = new org.omg.CORBA.Policy[1];
			policy[0] = JavaORB.policy.ThreadPolicyFactory.create_thread_servant_policy( JavaORB.ThreadServantPolicyValue.SINGLE_THREAD );
						
			c._set_policy_override( policy, org.omg.CORBA.SetOverrideType.SET_OVERRIDE );		
		}
		else
		if ( args[0].equals("request") )
		{
			System.out.println("THREAD_PER_REQUEST policy selected...");
			
			org.omg.CORBA.Policy [] policy = new org.omg.CORBA.Policy[1];
			policy[0] = JavaORB.policy.ThreadPolicyFactory.create_thread_servant_policy( JavaORB.ThreadServantPolicyValue.THREAD_PER_REQUEST );
						
			c._set_policy_override( policy, org.omg.CORBA.SetOverrideType.SET_OVERRIDE );		
		}
		else		
		{
			// nothing to do... default policy
			System.out.println("THREAD_PER_CLIENT policy selected...");
		}
								
		// 6. 
		// Export the object reference
		String reference = orb.object_to_string(c);
		try
		{
			java.io.FileOutputStream file = new java.io.FileOutputStream("ObjectId");
			java.io.PrintStream pfile=new java.io.PrintStream(file);
			pfile.println(reference);
		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
		}
		
		// 7.
		// Wait for incoming client connection
		try
		{	
			System.out.println("The server is ready...");
			boa.impl_is_ready();	
		}
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A system exception has been intercepted...");
			ex.printStackTrace();
		}
	}
}
